(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.truncate = truncate;

	var _truncator = __webpack_require__(1);

	var _dom = __webpack_require__(2);

	var _dom2 = _interopRequireDefault(_dom);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function truncate(el, text, options) {
	  if (typeof options === 'number') {
	    return (0, _truncator.truncateByHeight)(el, text, options);
	  }

	  if (options === null || (typeof options === 'undefined' ? 'undefined' : _typeof(options)) !== 'object') {
	    throw new Error('options must be number or object');
	  }

	  var domEl = (0, _dom2.default)(el);

	  if (typeof options.height === 'number') {
	    return (0, _truncator.truncateByHeight)(domEl, text, options.height);
	  }

	  if (typeof options.line === 'number') {
	    return (0, _truncator.truncateByLine)(domEl, text, Math.floor(options.line));
	  }

	  if (typeof options.count === 'number') {
	    return (0, _truncator.truncateByCount)(domEl, text, Math.floor(options.count));
	  }

	  throw new Error('options must have height, line or count as number');
	}

/***/ },
/* 1 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.truncateByLine = truncateByLine;
	exports.truncateByHeight = truncateByHeight;
	exports.truncateByCount = truncateByCount;
	function truncateByLine(el, text, line) {
	  truncateByHeight(el, text, el.lineHeight * line);
	}

	function truncateByHeight(el, text, height) {
	  el.text = text;

	  if (el.height <= height) {
	    return;
	  }

	  truncateImpl(el, text, height, 0, text.length);
	}

	function truncateByCount(el, text, count) {
	  el.text = text.substring(0, count) + '...';
	}

	function truncateImpl(el, text, maxHeight, left, right) {
	  var center = Math.floor((left + right) / 2);
	  var truncated = text.substring(0, center) + '...';
	  el.text = truncated;

	  if (left + 1 >= right) {
	    return;
	  }

	  var height = el.height;

	  if (height > maxHeight) {
	    truncateImpl(el, text, maxHeight, left, center);
	  } else {
	    // left index should always be included in search space
	    // because it might be boundary point of truncation
	    truncateImpl(el, text, maxHeight, center, right);
	  }
	}

/***/ },
/* 2 */
/***/ function(module, exports) {

	'use strict';

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = dom;

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Dom = function () {
	  function Dom(el) {
	    _classCallCheck(this, Dom);

	    this.el = el;
	    this.style = window.getComputedStyle(el, '');
	  }

	  _createClass(Dom, [{
	    key: 'text',
	    set: function set(val) {
	      if ('textContent' in this.el) {
	        this.el.textContent = val;
	      } else if ('innerText' in this.el) {
	        this.el.innerText = val;
	      } else {
	        throw new Error('The browser does not support text insertion for DOM');
	      }
	    }
	  }, {
	    key: 'height',
	    get: function get() {
	      return parseFloat(this.style.getPropertyValue('height'));
	    }
	  }, {
	    key: 'lineHeight',
	    get: function get() {
	      var origHTML = this.el.innerHTML;

	      this.el.innerHTML = 'X';
	      var height = this.height;
	      this.el.innerHTML = origHTML;

	      return height;
	    }
	  }]);

	  return Dom;
	}();

	function dom(el) {
	  return new Dom(el);
	}

/***/ }
/******/ ])
});
;